*********************************
Changelog for BwPostman Component
*********************************

This is a changelog for the Joomla!3.3.6+ component BwPostman 3.x and for Joomla!4.0.0 and BwPostman 4.x
Many thanks to all those people who have contributed bug reports and code fixes.

Version 4.0.0 released (2021-11-06)----

New
+ Adjustments to run on Joomla!4 native
+ Support for Bootstrap 2, 3, 4 and Cassiopeia at front end
+ Full support of the new routing for search engine friendly URLs


Version 3.1.7 released (2021-10-02)----

Bugfix
# Ensure BwTimeControl settings are written as CDATA to backup
# Ensure CDATA parts of backup are parsed correctly, even if there is only one dataset
# Base64 encode keys of BwTimeControl settings while creating backup and decode at restoring


Version 3.1.6 released (2021-08-21)----

Improvement
~ Smaller changes to manifest files of package and single parts to meet upgrade needs


Version 3.1.5 released (2021-06-11)----

New
+ Add option for selecting FE layout to component options

Bugfix
# Repair pagination at FE
# Correct calculating of start date (February 29/30 problem) at module overview
# Correct tooltip for publish at sent newsletter
# Correct typos at language strings, add missing strings, remove icon of BwLibRegister

Improvement
~ Install plugin BwLibregister as first element of installation package
~ Improve filter type at import of subscribers
~ Improve selecting of table columns to handle with CDATA at saving tables


Version 3.1.4 released (2021-03-05)----

Bugfix
# Check of tables after update did not work with Joomla 3.9.25


Version 3.1.3 released (2021-02-26)----

Bugfix
# In some rare cases tables are lost at check and restore of tables
# Link to manual at screen after installation/update didn't work correctly


Version 3.1.2 released (2021-02-03)----

Bugfix
# Moving subscribers to another mailing list by batch processing did not work


Version 3.1.1 released (2021-01-20)----

Bugfix
# CSS files of component not copied to media folder


Version 3.1.0 released (2021-01-14)----

New
+ Small and large modal layout and bootstrap layouts for registration module added
+ Call of css file moved to layout to enable separated css files for each layout
+ Support for bootstrap 2 + 4 added to front end files


Version 3.0.3 released (2020-11-27)----

Bugfix
# Modal window changes of disclaimer to bootstrap reverted

New
+ Provide custom header List-Unsubscribe for newsletter (email)


Version 3.0.2 released (2020-11-17)----

Bugfix
# Make IDs of edit_mailformat and gender select list of registration module unique
# Add required star to available mailinglists
# Repair display of special field
# Switch to get mailinglists by access level up to user access level (including lower levels)
# Format gender select list
# Repair saving of gender male


Version 3.0.1 released (2020-09-08)----

Bugfix
# Correct query for attribute at restoring tables
# Ignore and report unprocessable user groups at restore tables
# Catch some exceptions to prevent white screen on dashboard

Improvement
~ Sending mails by BwPostman without correct sender now nearly impossible


Version 3.0.0 released (2020-08-14)----

New
+ Enhanced mail verification at import of subscribers
+ Import of Joomla classes by php use
+ Sending of newsletters switched to ajax handling, improved look and feel
+ Log level of BwPostman selectable at options of component

Bugfix
# Avoid error message at deinstallation by not loading logger at deinstallation
# Add own sql update method to ensure these updates are handled correctly
# Error message at sending of newsletters resolved, if gzip compression is set at Joomla settings
# Use of group ids in place of english group names at restoring tables

Improvement
~ Memory usage, time consumption and error handling at restoring tables improved
~ Input data at front end and back end made more secure
~ Import of subscribes secured, information texts improved
~ Check of imported user groups at restoring tables enhances by default user groups
~ Adjust name of media folder of BwPostman to Joomla default
~ Personalization of managing mails introduced (i.e. confirmation mail)
~ Use of SimpleXML for creating and restoring tables and creating subscriber export
~ Inline javascript moved to files to improve security and loading time
~ Lot of code optimization (smaller methods, less code duplication, helper classes extended, …) as preparation for Joomla 4


Version 2.3.1 released (2019-06-08)----

Bugfix
# Multiple problems with language strings corrected


Version 2.3.0 released (2019-04-26)----

New
+ Message at front end, that new activation needed, if subscriber changed mail address
+ Plugin to show mailinglists/usergroups and optionally number of recipients of a newsletter at the footer of the newsletter
+ Language files moved to Transifex and except english and german removed from installation package to save installation package space and installation time. Installation separately.

Bugfix
# Error after click on icon for multiple attachments at front end

Improvement
~ Trigger for events added for future use
~ Rendering of newsletter before preview and sending modularized (internal work)
~ BwLibRegister library file moved from component folder to plugin folder


Version 2.2.1 released (7-Feb-2019)----

New
+ Dutch language files

Bugfix
# Mail to webmaster at unsubscription doesn't work
# Wrong inheritance of sample user groups

Improvement
~ Switch update server to package naming

Version 2.2.0 released (25-Jan-2019)----

New
+ Export subscribers only from selected mailing list possible
+ Content templates for newsletters
+ Specific help links to online documentation at backend

Bugfix
# SQL syntax error at newsletters list at front end
# Restore of tables with zip file doesn't work
# Export subscribers always exports all subscribers

Improvement
~ Up to 20 attachments possible


Version 2.1.2 released (14-Dez-2018)----

Improvement
~ Output checked for valid HTML
~ Table check at update moved to modal box
~ Comma at salutation at activation mail hard coded, sometimes a not needed space is set

Bugfix
# Missing media images at installation package
# Captcha doesn't work


Version 2.1.1 released (16-Nov-2018)----

New
+ All texts of options are multi-language capable
+ Modal box for disclaimer at front end, selectable at options of component

Bugfix
# Update crashes, if one of the Plugins U2S or B2S is activated
# Compression/Decompression of saved tables only works for Joomla! 3.8.1+
# SQL error at newsletter overview at front end
# Internal mailinglists are not accepted as recipients
# Update from 1.3.2 to 2.0.x lets display unpublished articles of Joomla


Version 2.1.0 released (26-Oct-2018)----

New
+ Component option for 1-click-unsubscribe
+ Component option mail to webmaster at unsubscription
+ Button Save & Copy for all sections
+ Button Save & New for all sections
+ Possibility to print subscriber data at subscriber details (GDPR)
+ Component option to pack file at save tables (ZIP)
+ Export for templates added
+ Component option to publish newsletter by default after sending
+ Additional optional checkbox with individual text directly before subscribe button (for GDPR)

Bugfix
# SQL error at newsletter list view at front end
# Error at upload file at attachments at edit newsletter
# Link to forum changed to new target

Improvement
~ Delete uploaded backup file after restoring tables
~ not needed images removed


Version 2.0.2 released (19-May-2018)

Bugfix
# Routing after save changes of subscription at FE
# Edit subscription only stored one mailing list
# Everlasting spinner at permission change at newsletters and subscribers
# Impossible to save assets of subscriber without gender selected
# Display of calculated permissions if permission changed corrected on item level

Improvement
~ Description of mailing list can be shown if only one mailing list to select exists
~ Description of mailing lists can be shortened, full description with tool tip for component, module and plugin
~ Permission create now hidden on item level, makes no sense
~ selecting gender changed to select list with 3 specific values (male, female, not specified)


Version 2.0.1 released (2-May-2018)

Bugfix
# Saving changed subscription with error


Version 2.0.0 released (1-May-2018)

With this version BwPostman only is distributed as package, that contains all that BwPostman contains for free. With this
version there is only this changelog available, separate change logs for modules and plugins are not longer updated.

New
+ Plugin for enhanced personalization
+ Plugin for subscription to a mailing list while creating a Joomla! account
+ Additional field "Custom CSS" at standard templates added
+ Buttons for enhanced personalization inserted at editing templates and newsletters

Bugfix
# Link to Boldt Webservice now totally removed when selected not to show
# Typos corrected at language files
# Table check at attribute NULL corrected
# Form check by javascript corrected
# Saving gender without entry (=gender unknown) now possible
# Change back to no gender now possible
# Table campaigns_mailinglists was not deleted at uninstall
# Check for module specific params corrected

Improvement
~ Collation of tables changed from utf8 to utf8mb4
~ Access management of component enhanced
~ Table column archived_by changed to integer
~ Email check at module subscription enhanced to meet new TLDs
~ CSS styles for radio buttons module subscription modified


Version 1.3.2 released (14-Apr-2016)

Improvement
~ Trigger for enhanced personalization modified.

Bugfix
# Since Joomla 3.5.1 some problems while registering or change subscribers mail address
# If folder for media was renamed, there occurred problems with attachment and thumbnails of templates
# If a user was logged in, which has no subscription, there occurred problems at register form
# Since Joomla 3.5.1 building of some language strings have changed
# "male" was not shown in back end list of subscribers.


Version 1.3.1 released (7-Apr-2016)

New
+ Trigger for enhanced personalization inserted.

Bugfix
# Since Joomla 3.5.1 sending newsletters failed
# Since Joomla 3.5.1 some php warnings arise while creating or editing newsletters or campaigns
# Handling of specific table permissions while updating BwPostman throws php warnings


Version 1.3.0 released (29-Mar-2016)

New
+ Possibility to import external created mail templates.
+ Selection for gender of subscriber, at options configurable.
+ Additional field for further purpose for subscriber, display and obligation configurable at options, label and description for label of additional field configurable also in options by language strings.
+ List of newsletter at back end displays, whether an attachment belongs to newsletter.
+ Assets of tables of BwPostman and their corresponding user groups will now be backed up and restored.

Improvement
~ Runtime at restoring tables up to 120 times faster.
~ Needed memory at update to new version of BwPostman drastically reduced by changing internal workflow.
~ Needed memory at restoring tables drastically reduced by changing internal workflow.
~ View of restoring and checking tables now continuously shows the working steps.
~ Asset handling at restoring tables revised.
~ Language files revised.

Bugfix
# Selecting attachment while creating/editing a newsletter was not possible


Version 1.2.4 released (17-Dec-2015)

Bugfix
# User-defined CSS file some times not read
# Faulty calling of icon font for user-defined css file
# Faulty function call in helper class
# Unable to delegate actions in BwPostman to other user groups

Improvement
~ Select lists for available and selected content at creating/editing newsletters broadened
~ Error message at missing inputs while creating a newsletter specified


Version 1.2.3 released (22-Sep-2015)

Bugfix
# Edit form subscriber in front end: click on a button does nothing, if one of the fields first name or name is not obligatory.
# On some installations updates to BwPostman were shown even update was already installed

- improvement:
~ Javascript noscript message added


Version 1.2.2 released (2-Sep-2015)

Improvement:
~ CSS of html templates improved to better fit Outlook specifics


Version 1.2.1 released (17-Jul-2015)

Bugfix
# Adding subscriber without name is not possible, even option is set to no obligation


Version 1.2.0 released (9-Jul-2015)

Bugfix
# Newsletters, that only contains free content without articles from Joomla, did not use the template
# Access control in view archive does not work properly
# Pagination in back end view of newsletters did not work properly
# Anchor links in newsletters did not work

New
+ Selecting campaign moved up to General Information at edit newsletter tab Generals
+ Recipients of campaigns now selectable at campaigns, not at newsletters
+ Publish up and publish down for newsletters, concerns visibility in frontend
+ Status, description and publishing times of sent newsletters editable
+ Delay time between sending of newsletter packages selectable
+ Access to attachment of a newsletter in front end, selectable by global option and menu item option
+ Extended options for view newsletters list in front end
+ Filter newsletters in front end list view by mailing lists, usergroups, campaigns, month and year enable by global option and menu item option
+ More additional filters in back end list views

- improvement:
~ Improved loading time and stability while editing newsletter in back end
~ Improved work flow at import and export of subscribers
~ Progress bar while sending newsletters
~ Improved and modernized look in front end
~ CSS files for front end now contains all elements used by BwPostman (most of them empty to fill by user)


Version 1.1.0.1 released (14-Apr-2015)

Bugfix
# Pagination does not work since Joomla 3.3.4
# Confirmation date of subscriber was set on actual date on each saving
# Newsletters to usergroups are not shown in front end

Improvement
~ Templates added to statistics
~ Styles for pagination in front end added


Version 1.1.0 released (21-Mar-2015)

Bugfix
# Newsletters without articles of Joomla have not used CSS styles

New
+ Template system for newsletters (Karl)
+ dropped support for Joomla 2.5

Improvement
~ Extended and improved filtering in back end


Version 1.0.8 released (Mar-05-2015)

*********************************************
*** last version that supports Joomla!2.5 ***
*********************************************

New
+ Filtering for mailing lists in view subscribers implemented
+ Batch processing for add, remove or move subscribers to/from/between mailinglists
+ Icon set for back end joomla menu entries extended

Improvement
~ Subject of a newsletter now may be used several times
~ Description for newsletter added
~ Version of BwPostman in file name of saved tables
~ List of newsletters in front end now ordered by date descending as default
~ List of mailing lists while creating/editing a newsletter now ordered by title ascending


Version 1.0.7 released (Feb-18-2015)

Bugfix
# Corrupt language file
# Read more link in newsletter causes error 404 - file not found - if language of the article does not meet the language of the website on multi-language sites
# Archived recipients were not deleted from queue

Improvement
~ Code is more valid
~ Icons in back end menus of Joomla


Version 1.0.6 released (Jan-05-2015)

Bugfix
# Editing newsletters step 3 preview not shown, sending of newsletters not possible


Version 1.0.5 released (Dec-18-2014)

Bugfix
# User-defined css file not read
# In some cases error 1052 while editing subscribers

Improvement
~ Checkall implemented in back-end subscribers at tab unconfirmed subscribers


Version 1.0.4 released (Oct-29-2014)

Bugfix
# selecting attachment others than images is not possible
# sorting newsletters list in front-end is not possible
# In view newsletters in back-end at tab Sent newsletters nothing shown as marked at check all
# Search phrase in newsletters list at front-end was not reset in some cases
# Page title at front-end views not always set correctly


Version 1.0.3 released (Oct-14-2014)

Bugfix
# problem while browsing pages with subscribers and newsletters in backend
# false error message "invalid email address" while importing subscribers, no import possible
# no items visible in queue
# Value for "Number of newsletters per step" in tab "Step5: Send newsletter" was not used
# some compatibility issues with javascript
# editor not accessible in tab "Step2: HTML newsletter"


Version 1.0.2 released (Sep-20-2014)

Improvement
~ spam check revised
~ error messages revised

Bugfix
# revised, corrected and updated language strings
# sending newsletters to joomla usergroups was not possible


Version 1.0.1 released (Aug-07-2014)

New
+ works now with Joomla!3.3
+ maintenance with check and repair tables, save tables and restore tables
+ new icon set
+ integrated help accessible in toolbar
+ easy migration from one Joomla! installation to another conditionally possible

- improvement:
~ better overview of basic settings by improved layout of options
~ disclaimer now also selectable from Joomla! articles or Joomla! menu
~ conversion from _all/_single file and class naming to Joomla! conventions
~ table engine changed to InnoDB
~ list(s) renamed to mailinglist(s) in tables, controllers, models and views
~ mostly revised and simplified code

Bugfix
# Minor discrepancies in the client-side and server-side validation of form fields has been corrected.


Version 0.9.8.1 released (Apr-13-2014)

Bugfix ERROR 500 - Unknown column 'attachment' in 'field list' SQL=INS…


Version 0.9.8 released (Apr-09-2014)

New
+ Significant is the improvement of protection against spam entries in the registration forms (component and module).
+ The administrator has now the option to integrate in the registration form:
	- a user-defined control question
	- or a captcha with a simple math question

Improvement
~ The display of the article author and the creation date in the newsletter can be controlled in the options.

Bugfix
# Minor bugs in the client-side and server-side validation of form fields has been corrected.


Version 0.9.7 released (Mar-08-2014)

New
+ Sending an attachment with the newsletter is now possible
+ There is a new tab Advanced Settings added to options/settings for:
	- Legal information
	- A title in the activation mail
	- Various texts for the activation mail
	- You are able to set, that you will be informed at each confirmation per mail
	- A user-defined CSS-File named com_bwpostman.css, located in [your template]/css, will be used and overrides the css-styles predefined in BwPostman

Improvement
~ If name und first name are set to required, then the fields will be displayed at registration even if you forgot to set to display these fields
~ All elements shown in frontend are individually selectable by CSS now
~ Revised installation routine


Version 0.9.6.4 released (Jan-23-2014)

Bugfix
# Can't register in component register form, when only one mailing list is available
# When component register form and module form are displayed at same time, one has to fill both forms to be able to register


Version 0.9.6.3 released (Sept-07-2013)

Bugfix
# for updating version number

Improvement
~ installation script revised


Version 0.9.6.1 released (Sept-02-2013)

Bugfix
# registering to newsletter


Version 0.9.6 released (Aug-22-2013)

New
+ css-asset for module added


Version 0.9.5 released (Aug-21-2013)

New
+ field 'firstname' inserted with separated option for show/required to field 'name'
+ personalization for HTML- als text-newsletters inserted

Bugfix
# error while copying newsletter eliminated


Apr-05-2013 Romana Boldt, Version 0.9.1
~ general changes to Joomla! 2.5

